#ifndef UTILITIES_H
#define UTILITIES_H

#include <glm.hpp>
#include <string>
#include <map>
#include <tuple>
#include "Sphere.h"
#include "HPModel.h"
#include "Renderer.h"

bool WorldToScreen(const glm::vec3& worldPos, const glm::mat4& view,
                  const glm::mat4& projection,
                  float screenWidth, float screenHeight,
                  float& screenX, float& screenY);

bool parseHPModelJson(const std::string& jsonInput,
                      std::map<std::tuple<int, int, int>, Sphere>& spheres,
                      std::vector<std::tuple<int, int, int>>& sphereSequence,
                      std::string& errorMessage);

void visualizeHPModel(Renderer* renderer, const HPModel& model);
#endif
